local VERSION = tonumber(("$Revision: 42466 $"):match("%d+"))

local Parrot = Parrot
if Parrot.revision < VERSION then
	Parrot.version = "r" .. VERSION
	Parrot.revision = VERSION
	Parrot.date = ("$Date: 2007-07-02 02:00:39 -0400 (Mon, 02 Jul 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local L = Parrot:L("Parrot-AnimationStyles")

Parrot:RegisterAnimationStyle("Straight", L["Straight"], function(fontstring, scrollArea, percent)
	local fsHeight = fontstring:GetHeight()
	local height = scrollArea.height - fsHeight
	local bottom = scrollArea.yOffset
	local center = scrollArea.xOffset
	if scrollArea.reverse then
		percent = 1 - percent
	end
	local y = bottom + percent * height
	local x = center
	local align = scrollArea.align
	local point
	if align == "LEFT" then
		point = "BOTTOMLEFT"
	elseif align == "RIGHT" then
		point = "BOTTOMRIGHT"
	else -- center
		point = "BOTTOM"
	end
	fontstring:SetPoint(point, UIParent, "CENTER", x, y)
end)
Parrot:RegisterAnimationStyle("Left parabola", L["Left parabola"], function(fontstring, scrollArea, percent)
	local fsHeight = fontstring:GetHeight()
	local height = scrollArea.height - fsHeight
	local bottom = scrollArea.yOffset
	local center = scrollArea.xOffset
	if scrollArea.reverse then
		percent = 1 - percent
	end
	local y = bottom + percent * height
	local x = center
	local align = scrollArea.align
	local point
	if align == "LEFT" then
		point = "BOTTOMLEFT"
	elseif align == "RIGHT" then
		point = "BOTTOMRIGHT"
	else -- center
		point = "BOTTOM"
	end
	x = x - (1 - (percent - 0.5)^2) * height * 1/2
	fontstring:SetPoint(point, UIParent, "CENTER", x, y)
end)
Parrot:RegisterAnimationStyle("Right parabola", L["Right parabola"], function(fontstring, scrollArea, percent)
	local fsHeight = fontstring:GetHeight()
	local height = scrollArea.height - fsHeight
	local bottom = scrollArea.yOffset
	local center = scrollArea.xOffset
	if scrollArea.reverse then
		percent = 1 - percent
	end
	local y = bottom + percent * height
	local x = center
	local align = scrollArea.align
	local point
	if align == "LEFT" then
		point = "BOTTOMLEFT"
	elseif align == "RIGHT" then
		point = "BOTTOMRIGHT"
	else -- center
		point = "BOTTOM"
	end
	x = x + (1 - (percent - 0.5)^2) * height * 1/2
	fontstring:SetPoint(point, UIParent, "CENTER", x, y)
end)

Parrot:RegisterAnimationStyle("Pow", L["Pow"], function(fontstring, scrollArea, percent, num, max)
	local fsHeight = fontstring:GetHeight()
	local middle = scrollArea.yOffset + scrollArea.height / 2
	local center = scrollArea.xOffset
	local reverse = scrollArea.reverse
	local topMiddle
	local topDiff = (max - 1) * 0.5 * fsHeight
	local currDiff = -(num - 1) * fsHeight
	local y
	if not reverse then
		y = middle + topDiff + currDiff
	else
		y = middle - topDiff - currDiff
	end
	
	local x = center
	local point = scrollArea.align
	-- now for squiggle
	local time = GetTime()
	if not fontstring.nextSquiggle or fontstring.nextSquiggle < time then
		fontstring.nextSquiggle = time + 0.05
		fontstring.squiggleX = math.random(-1, 1)
		fontstring.squiggleY = math.random(-1, 1)
	end	
	x = x + fontstring.squiggleX
	y = y + fontstring.squiggleY
	
	fontstring:SetPoint(point, UIParent, "CENTER", x, y)
end, function(fontstring, scrollArea)
	fontstring.nextSquiggle = nil
	fontstring.squiggleX = nil
	fontstring.squiggleY = nil
end)
